SystemOrganization addCategory: #ConfigurationOfOmniVM!

Object subclass: #ConfigurationOfOmniVM
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfOmniVM'!

!ConfigurationOfOmniVM class methodsFor: 'development support' stamp: 'StefanMarr 8/6/2012 17:09'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfOmniVM class methodsFor: 'private' stamp: 'StefanMarr 8/6/2012 17:09'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfOmniVM class methodsFor: 'private' stamp: 'StefanMarr 8/6/2012 17:09'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfOmniVM class methodsFor: 'private' stamp: 'StefanMarr 8/6/2012 17:09'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfOmniVM class methodsFor: 'metacello tool support' stamp: 'StefanMarr 8/6/2012 17:09'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfOmniVM class methodsFor: 'loading' stamp: 'StefanMarr 8/6/2012 17:09'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfOmniVM class methodsFor: 'loading' stamp: 'StefanMarr 8/6/2012 17:09'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfOmniVM class methodsFor: 'loading' stamp: 'StefanMarr 8/6/2012 17:09'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfOmniVM class methodsFor: 'accessing' stamp: 'StefanMarr 8/6/2012 17:09'!
project

	^self new project! !

!ConfigurationOfOmniVM class methodsFor: 'development support' stamp: 'StefanMarr 8/6/2012 17:09'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfOmniVM methodsFor: 'baselines' stamp: 'StefanMarr 8/6/2012 17:25'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		
		spec project: 'Benchmarking' with: [
				spec
					className: 'ConfigurationOfBenchmarking';
					versionString: #'bleedingEdge';
					repository: 'http://www.squeaksource.com/SMark' ].
		
		spec package: 'RoarVM' with: [spec repository: 'http://ss3.gemstone.com/ss/RoarVM'].
		
		spec repository: 'http://ss3.gemstone.com/ss/OmniVM'.
		
		spec
			package: 'OmniVMNoOpt' with: [
				spec requires: #('RoarVM')];
	
			package: 'ClojureST' with: [
				spec requires: #('OmniVMNoOpt' )];
			
			package: 'OmniST-Languages' with: [
				spec requires: #('OmniVMNoOpt' 'ClojureST')];
			
			package: 'OmniST-CLBG-Compatibility' with: [
				spec requires: #('OmniVMNoOpt' 'Benchmarking')];
			 
			package: 'OmniST-Benchmarks' with: [
				spec requires: #('OmniVMNoOpt' 'OmniST-Languages' 'OmniST-CLBG-Compatibility')];
			
			package: 'OmniST-Tests-Core' with: [
				spec requires: #('OmniVMNoOpt')];
			
			package: 'OmniST-Tests-Languages' with: [
				spec requires: #('OmniST-Languages')];
			
			package: 'AmbientTalkST-Benchmarks' with: [
				spec requires: #('OmniST-Languages' 'OmniST-Benchmarks')]

		
		
		].
! !

!ConfigurationOfOmniVM methodsFor: 'accessing' stamp: 'StefanMarr 8/6/2012 17:09'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !
